local material_config_ids = Idstring("material_config")

local armor_objects = {
	level_5 = {Idstring("g_vest_shoulder")},
	level_6 = {Idstring("g_vest_shoulder")},
	level_7 = {Idstring("g_vest_shoulder"), Idstring("g_vest_leg_arm")}
}

Hooks:PostHook(CriminalsManager, "set_beardlib_character_visual_state", "FPSArmour_CharacterVisualState", function(unit, character_name, visual_state)
	local is_local_peer = visual_state.is_local_peer

	if is_local_peer then
		local player_style = visual_state.player_style
		local suit_variation = visual_state.suit_variation
		local armor_id = visual_state.armor_id
		local armor_skin = visual_state.armor_skin

		if not alive(unit) then
			return
		end

		if _G.IS_VR and unit:camera() then
			return
		end

		if unit:camera() and alive(unit:camera():camera_unit()) and unit:camera():camera_unit():damage() then
			unit = unit:camera():camera_unit()
		end

		if not unit:damage() then
			return
		end

		local function get_value(value, fallback)
			local value_string = tostring(value)
			local output = tweak_data.blackmarket:get_suit_variation_value(player_style, suit_variation, character_name, value_string)
			if not output then
				output = tweak_data.blackmarket:get_player_style_value(player_style, character_name, value_string) or fallback
			end

			return output
		end

		local body_replacement = get_value("body_replacement", {})

		if unit:spawn_manager() then
			unit:spawn_manager():remove_unit("armor_mesh")

			local hidden = armor_id == "level_2" and body_replacement.vest or body_replacement.armor
			if not hidden and armor_objects[armor_id] then
				unit:spawn_manager():spawn_and_link_unit("_char_joint_names", "armor_mesh", "units/mod_fps_armor/characters/fps_armor_arms/fps_armor_arms")
				local armor_mesh_unit = unit:spawn_manager():get_unit("armor_mesh")

				if alive(armor_mesh_unit) then
					for _, object_ids in pairs(armor_objects[armor_id]) do
						local object = armor_mesh_unit:get_object(object_ids)
						if object then
							object:set_visibility(true)
						end
					end

					if armor_mesh_unit:armor_skin() and armor_mesh_unit:armor_skin().set_armor_id then
						local armor_skin_ext = armor_mesh_unit:armor_skin()
						local cosmetic_data = armor_skin and tweak_data.economy.armor_skins[armor_skin]

						local use = armor_skin_ext:use_cc()
						local use_cc_material_config = use and cosmetic_data and not cosmetic_data.ignore_cc and true or false

						if use_cc_material_config then
							local new_material_config_ids = armor_skin_ext:_get_cc_material_config()
							if new_material_config_ids and DB:has(material_config_ids, new_material_config_ids) then
								armor_mesh_unit:set_material_config(new_material_config_ids, true)
							end
						end

						armor_skin_ext:set_armor_id(armor_id)
						armor_skin_ext:set_cosmetics_data(armor_skin, true)
					end
				end
			end
		end
	end
end)